commit 2f19541492aee1ecbc5b3f80f1defbc8c62bf078
Author: freddy77 <freddy77>
Date:   Thu Dec 11 10:14:19 2008 +0000

    add test for thread

diff --git a/ChangeLog b/ChangeLog
index d5cf670..c615d31 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu Dec 11 11:11:34 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/cancel.c: add test for thread
+
 Wed Dec 10 18:07:31 EST 2008	JK Lowden <jklowden@freetds.org>
 	* doc/userguide.sgml
 	- add osql to unixODBC troubleshooting 
@@ -1021,4 +1024,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2673 2008/12/10 23:12:18 jklowden Exp $
+$Id: ChangeLog,v 1.2674 2008/12/11 10:14:19 freddy77 Exp $
diff --git a/src/odbc/unittests/cancel.c b/src/odbc/unittests/cancel.c
index 239707d..be887a0 100644
--- a/src/odbc/unittests/cancel.c
+++ b/src/odbc/unittests/cancel.c
@@ -10,7 +10,9 @@
 #include <unistd.h>
 #endif /* HAVE_UNISTD_H */
 
-#ifdef HAVE_ALARM
+#if defined(TDS_HAVE_PTHREAD_MUTEX) && HAVE_ALARM
+
+#include <pthread.h>
 
 static char sqlstate[SQL_SQLSTATE_SIZE + 1];
 
@@ -53,27 +55,76 @@ sigalrm_handler(int s)
 	signal(SIGALRM, exit_forced);
 }
 
-int
-main(int argc, char **argv)
+volatile int exit_thread;
+
+static void *
+wait_thread_proc(void * arg)
 {
-	use_odbc_version3 = 1;
-	Connect();
+	int n;
+
+	sleep(4);
+
+	printf(">>>> SQLCancel() ...\n");
+	CHKCancel("S");
+	printf(">>>> ... SQLCancel done\n");
+	
+	for (n = 0; n < 4; ++n) {
+		sleep(1);
+		if (exit_thread)
+			return NULL;
+	}
+
+	exit_forced(0);
+	return NULL;
+}
 
+static void
+Test(int use_threads)
+{
+	pthread_t wait_thread;
+
+	printf("testing with %s\n", use_threads ? "threads" : "signals");
 	printf(">> Wait 5 minutes...\n");
-	alarm(4);
-	signal(SIGALRM, sigalrm_handler);
+	if (!use_threads) {
+		alarm(4);
+		signal(SIGALRM, sigalrm_handler);
+	} else {
+		int err;
+
+		exit_thread = 0;
+		err = pthread_create(&wait_thread, NULL, wait_thread_proc, NULL);
+		if (err != 0) {
+			perror("pthread_create");
+			exit(1);
+		}
+	}
 	CHKExecDirect((SQLCHAR *) "WAITFOR DELAY '000:05:00'", SQL_NTS, "E");
-	alarm(0);
+	exit_thread = 1;
+	if (!use_threads) {
+		alarm(0);
+	} else {
+		pthread_join(wait_thread, NULL);
+	}
 	getErrorInfo(SQL_HANDLE_STMT, Statement);
 	if (strcmp(sqlstate, "HY008") != 0) {
 		fprintf(stderr, "Unexpected sql state returned\n");
 		Disconnect();
-		return 1;
+		exit(1);
 	}
 
 	ResetStatement();
 
 	Command("SELECT name FROM sysobjects WHERE 0=1");
+}
+
+int
+main(int argc, char **argv)
+{
+	use_odbc_version3 = 1;
+	Connect();
+
+	Test(0);
+	Test(1);
 
 	Disconnect();
 	return 0;

